*___________________________________________________________________________________________________________________;
*___________________________________________________________________________________________________________________;
*___________________________________________________________________________________________________________________;
*Identify all firms in CPST with positive assets, sales, and non-missing net income;
	*For Table 2, Panel C;

*First year of any violation beginning (all the way back to 1979, with enforcement proceedings ending after SOX);

dm 'log;clear;';


*Get asset data for firm_years;
*Rsubmit set-up;
%let wrds = wrds.wharton.upenn.edu 4016; 
options comamid=TCP remote=WRDS;
signon username=_prompt_;
Libname rwork slibref=work server=wrds;

rsubmit;
%include '!SASROOT/wrdslib.sas' ;
libname  home '/home/iowa/jhw27/';
libname temp '/sastemp7';
endrsubmit;

*First year of any violation beginning (all the way back to 1979, with enforcement proceedings ending after SOX);
rsubmit;
data cdata_raw; set comp.funda
(keep = gvkey datadate fyear at sale ni indfmt datafmt popsrc consol curcd);
where (fyear ge 1979) and (fyear le 2014)
		and (indfmt='INDL') and (datafmt='STD') and (popsrc='D') and (consol='C')
		and (curcd='USD') and (at > 0) and (sale > 0) and (ni ne .) /*and (fic eq "USA")*/;
drop indfmt datafmt popsrc consol curcd;
run;

data company; set comp.company
(keep = gvkey sic);
run;
endrsubmit;

*Merge in data;
rsubmit;
proc sql; create table cdata_raw1 as select distinct
		a.*,b.sic
		from cdata_raw as a 
		left join company as b
		on a.gvkey eq b.gvkey 
		order by gvkey;
		quit;

proc sort nodupkey; by gvkey;
run;

proc download data=cdata_raw1 out = cpstfirms;
run;

endrsubmit;


data cpstfirms; set cpstfirms;
where (1979 <= fyear <= 2012);
sic_n = sic*1;
run;


*export to Stata for analysis;
PROC EXPORT DATA= cpstfirms
            OUTFILE= "C:\Users\jhwilde\Dropbox\CMSW\STATA\cpstfirms1.dta" 
            DBMS=STATA REPLACE;
RUN;
